CON

  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000

'SD Card pins:

  DO_PIN        = 22
  CLK_PIN       = 23
  DI_PIN        = 24
  nCS_PIN       = 25

'Serial I/O pins:

  GPS_PIN       = 16
  PC_OUT        = 30

'Write indicator:

  LED_PIN       = 26

'Unit ID:

  UNIT          = "0"

OBJ

  sio   : "FullDuplexSerial"
  sd    : "fsrw"

PUB start

  sio.start(GPS_PIN, PC_OUT, 0, 4800)
  sd.mount_explicit(DO_PIN, CLK_PIN, DI_PIN, nCS_PIN)
  filename[7] := UNIT
  dira[26]~~
  
  waitcnt(cnt + clkfreq)
  repeat
    waitstr(string("$GPRMC,"))
    getstr(@time, 10)
    if (time[5] == "0" or time[5] == "5")
      sio.rx
      if (sio.rx == "A")
        sio.rx
        getstr(@lat, 9)
        waitstr(string("N,"))                           'Change to "S" for southern hemisphere.
        getstr(@lon, 10)
        sio.str(@time)
        outa[26]~~                                      'Turn LED on during write, so it won't be interrupted by flipping off the power.
        sd.popen(@filename, "a")                        'Open the file to append data.
        sd.pwrite(@time, strsize(@time))                'Write the time and position line to the file.
        sd.pclose                                       'Do a close to stat the file.
        outa[26]~                                       'Turn off the LED.
      else
        sio.tx("*")
      
PUB waitstr(strptr) | ptr, match

  ptr := strptr
  repeat while match := byte[ptr++]
    if (sio.rx <> match)
      ptr := strptr

PUB getstr(strptr, len)

  repeat len
    byte[strptr++] := sio.rx

DAT

filename      byte      "gpsdata_.txt"
time          byte      "dddddd.ddd,"
lat           byte      "ddmm.mmmm,"
lon           byte      "dddmm.mmmm",13,0    
  